#ifndef TIB_H
#define TIB_H

/*
 *	Based off of tib.h from Matt Pietrek in Microsoft Systems Journal "Under the Hood", May 1996	
 */

#pragma pack(1)

typedef struct _ENV 
{
	ULONG unknown1;
	ULONG unknown2;
	ULONG unknown3;
	ULONG unknown4;
	ULONG unknown5;
	ULONG unknown6;
	HANDLE hStdIn;
	HANDLE hStdOut;
	HANDLE hStdErr;

} ENV, *PENV;

typedef struct _PEB
{
	ULONG unknown1;
	ULONG unknown2;
	ULONG unknown3;
	ULONG unknown4;
	struct _ENV *pEnv;
} PEB;

typedef struct _TIB
{
	PVOID pvExcept;						// 00h Head of exception record list
	PVOID   pvStackUserTop;   // 04h Top of user stack
	PVOID   pvStackUserBase;  // 08h Base of user stack
	PVOID SubSystemTib;				// 0Ch
	ULONG FiberData;					// 10h
	PVOID   pvArbitrary;      // 14h Available for application use
	struct _TIB *ptibSelf;    // 18h Linear address of TIB structure
	ULONG unknown1;           // 1Ch
	ULONG processID;          // 20h
	ULONG threadID;           // 24h
	ULONG unknown2;           // 28h
	PVOID*  pvTLSArray;       // 2Ch Thread Local Storage array
	struct _PEB *pPEB;				// 30h Pointer to owning process database
} TIB, *PTIB;

#pragma pack()

#endif
